#include "Precompiled.h"
#include "BaseTransferDlg.h"
#include "Track.h"
#include "BaseNomad.h"
#include "Action.h"
#include "ActionTable.h"

BaseTransferDlg::BaseTransferDlg(ActionTable* pActionTable, Nomad* pNomad)	
	: wxDialog((wxWindow*)NULL, -1, wxString(_T("Transfer")), 
	wxDefaultPosition, wxDefaultSize, wxRAISED_BORDER|wxCAPTION|wxRESIZE_BORDER),
	m_pActionTable(pActionTable), m_pNomad(pNomad),
	m_dBytesTotal(0.0), m_dBytesDone(0.0),
	m_bAbort(false), m_bProcessing(false)
{
//	EnableCloseButton(FALSE);
	wxStaticBoxSizer *outlineSizer = new wxStaticBoxSizer(
		new wxStaticBox(this, -1, _T("")), wxVERTICAL );
	m_pProgress = new wxGauge(this, ID_PROGRESS, 100, wxPoint(-1, -1),
					   wxSize( 400, 20) );
	outlineSizer->Add(m_pProgress, 0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL|wxALL, 3);
	m_plblCurrTrack = new wxStaticText(this, -1, "", wxPoint(-1, -1),
					   wxSize( 400, 60), wxALIGN_CENTRE|wxST_NO_AUTORESIZE);
	outlineSizer->Add(m_plblCurrTrack, 0, 0);
	wxBoxSizer *psizerTop = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *psizerButton = new wxBoxSizer(wxHORIZONTAL);
	m_pAbort = new wxButton(this, ID_ABORT, _T("  Abort  "), wxPoint(-1, -1),
					   wxSize( 80, 29)); 
	psizerButton->Add(m_pAbort, 0, wxALIGN_CENTER | wxALL, 5);
	psizerTop->Add(outlineSizer, 0, wxALIGN_CENTER|wxALL, 3); 
	psizerTop->Add(psizerButton, 0, wxALIGN_CENTER|wxALL, 3); 
	SetAutoLayout(TRUE);
	SetSizer(psizerTop);
	psizerTop->SetSizeHints(this);
	psizerTop->Fit(this);
	m_pAbort->SetFocus();
	m_pAbort->SetDefault();
}	// constructor

void BaseTransferDlg::Init()
{
	m_dBytesTotal = 0;
	for (unsigned int n = 0; n < m_listAction.size(); n++)
	{
		if (m_listAction[n]->IsPending()) 
			m_dBytesTotal += m_listAction[n]->GetTimeNeeded();
	}
	m_pProgress->SetValue(0);
	m_plblCurrTrack->SetLabel("");
	m_pAbort->SetLabel("  Abort  ");
	m_bAbort = false;
}

BaseTransferDlg::~BaseTransferDlg()
{
}

void BaseTransferDlg::OnAbort(wxCommandEvent& WXUNUSED(event))
{
	wxLogMessage("Abort pressed!!\n");			
	m_pAbort->SetLabel("Aborting...");
	((BaseNomad*)m_pNomad)->CancelTransfer();
	m_bAbort = true;
	RequestClose();
}

void BaseTransferDlg::SetProgress(double dBytesDone)
{
	int nProgress = (int)(dBytesDone*100.0/m_dBytesTotal);
//	wxLogMessage("dBytesDone: %d, Total = %d%%", (int)dBytesDone, nProgress);
	if (nProgress > 100) nProgress = 100;
	if (nProgress < 0) nProgress = 0;
	m_pProgress->SetValue(nProgress);
}
