#ifndef _BaseTransferDlg_H_INCLUDED_
#define _BaseTransferDlg_H_INCLUDED_

#include <vector>
using namespace std;

class Nomad;
class ActionTable;
class Action;

const int ID_PROGRESS = 1001;
const int ID_ABORT = 1002;

typedef vector<Action*> ActionList;


class BaseTransferDlg : public wxDialog
{
public:
	BaseTransferDlg(ActionTable* pActionTable, Nomad* pNomad);
	~BaseTransferDlg();
	virtual void RequestClose() = 0;
	bool GetAbort() const
	{
		return m_bAbort;
	}
	void SetProgress(double dBytesDone);
	ActionList& GetActionList() 
	{
		return m_listAction;
	}
	void OnAbort(wxCommandEvent& WXUNUSED(event));
protected:
	void Init();
	wxGauge* m_pProgress;
	wxStaticText* m_plblCurrTrack;
	wxButton* m_pAbort;
	ActionTable* m_pActionTable;
	Nomad* m_pNomad;
	ActionList m_listAction;
	double m_dBytesTotal;
	double m_dBytesDone;	
	wxTimer m_timer;
	bool m_bAbort;
	bool m_bProcessing;	
};





#endif // _BaseTransferDlg_H_INCLUDED_
