#include "Precompiled.h"
#include "EzMessageBox.h"

int EzMessageBox(const wxString& strCaption, const wxString& strIDPrompt, int nType, 
	const wxString& strIDButton1, const wxString& strIDButton2, 
	const wxString& strIDButton3)
{
	EzMessageBoxDlg dlg(NULL, strCaption, strIDPrompt, nType, strIDButton1, 
		strIDButton2, strIDButton3);
	return dlg.ShowModal();
}


const int IDC_BUTTON = 1001;

BEGIN_EVENT_TABLE(EzMessageBoxDlg, wxDialog)
    EVT_BUTTON(-1, EzMessageBoxDlg::OnButton)
END_EVENT_TABLE()

EzMessageBoxDlg::EzMessageBoxDlg(wxWindow* pParent, const wxString& strCaption, 
	const wxString& strIDPrompt, int nType, 
	const wxString& strIDButton1, const wxString& strIDButton2, 
	const wxString& strIDButton3) 
	: wxDialog(pParent, -1, strCaption)
{
	wxBoxSizer *psizerTop = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *psizerButton = new wxBoxSizer(wxHORIZONTAL);
	wxFont font = GetFont();
	int nWidth = 0;
	int nHeight = 18;
	GetTextExtent("W", &nWidth, &nHeight, NULL, NULL, &font);
	psizerTop->Add(0, 10, 0, wxGROW); // spacer
	wxStaticText* pPrompt = new wxStaticText(this, -1, strIDPrompt, wxPoint(-1, -1),
					   wxSize( -1, -1), wxALIGN_CENTRE);
	psizerTop->Add(pPrompt, 0, wxEXPAND|wxALL, 5);
//	wxButton* pButton; 
//	for (int n = 0; n < 3; n++)
	wxButton* pButton1 = new wxButton(this, IDC_BUTTON, strIDButton1); 
	psizerButton->Add(pButton1, 0, wxALIGN_CENTER | wxALL, 5);
	if (!strIDButton2.IsEmpty())
	{
		wxButton* pButton2 = new wxButton(this, IDC_BUTTON+1, strIDButton2); 
		psizerButton->Add(pButton2, 0, wxALIGN_CENTER|wxALL, 5);
	}
	psizerTop->Add(psizerButton, 0, wxALIGN_CENTER|wxALL, 3); 
	SetAutoLayout(TRUE);
	SetSizer(psizerTop);
	psizerTop->SetSizeHints(this);
	psizerTop->Fit(this);
	pButton1->SetFocus();
	pButton1->SetDefault();
}

void EzMessageBoxDlg::OnButton(wxCommandEvent& event)
{
	EndModal(event.GetId() - IDC_BUTTON + 1);
}
