#ifndef _LNOMAD_H_INCLUDED_
#define _LNOMAD_H_INCLUDED_

#include "Track.h"
#include "BaseNomad.h"

class Track;
class Playlist;

struct njb_struct;
struct njb_songid_struct;


class Nomad	: public BaseNomad
{
public:
	Nomad();
	virtual ~Nomad();
	virtual bool InitJukeBox();
	virtual bool StartLoadAllTracks();
	virtual bool MoveNextTrack();
	virtual Track* LoadTrackData();
	virtual bool SendItem(Track* pTrack);
	virtual bool GetItem(const Track* pTrack, wxFileName& fileSpec);
	virtual bool DeleteItem(const Track* pTrack);
	virtual bool DeleteItem(const Playlist* pPlaylist);
	virtual bool SendLabel(const Track* pTrackPC, 
		const Track* pTrackNomad);
	virtual Playlist* GetFirstPlaylist();
	virtual Playlist* GetNextPlaylist();
	virtual bool SendPlaylist(Playlist* pPlaylist);
	virtual bool GetPlaylistTracks();
	bool IsUnicodeSupported();
	void SetCurrentDone(int nCurrentDone) 
	{
		m_nCurrentDone = nCurrentDone;
	}
	int GetCurrentDone() const
	{
		return m_nCurrentDone;
	}
	virtual void CancelTransfer()
	{
		m_bCancelTransfer = true;
	}
	bool GetCancelTransfer()
	{
		return m_bCancelTransfer;
	}
	virtual wxString GetLastErrorStr() const;
private:
	int ProgressUp(u_int64_t sent, u_int64_t total, const char* buf, unsigned len);
	static int WrapperProgressUp(u_int64_t sent, u_int64_t total, const char* buf, unsigned len, void *data);
	int ProgressDown(u_int64_t sent, u_int64_t total, const char* buf, unsigned len);
	static int WrapperProgressDown(u_int64_t sent, u_int64_t total, const char* buf, unsigned len, void *data);
	njb_struct* m_pJukeBox;
//	njb_t* m_parrayJBs; 
	njb_songid_struct* m_pSongID;
	bool m_bConnected;
	int m_nCount;
	int m_nCurrentDone;
	bool m_bCancelTransfer;
};





#endif // _LNOMAD_H_INCLUDED_
