#ifndef TransferDlg_H
#define TransferDlg_H

#include "BaseTransferDlg.h"
#include <wx/thread.h>

using namespace std;

class WorkerThread;

class TransferDlg : public BaseTransferDlg
{
public:
	TransferDlg(ActionTable* pActionTable, Nomad* pNomad);
	~TransferDlg(); 
	virtual bool TransferDataToWindow();
	void SetThreadFinished(bool b)
	{
		m_bThreadFinished = b;
	}
	virtual void RequestClose() {} 
	void SetCurrentAction(Action* pAction);
	void AddBytesDone(int nAdd)
	{
		m_dBytesDone += nAdd;
	}
private:
	DECLARE_EVENT_TABLE()
	void OnTimer(wxTimerEvent &event);
	void StartThread();
	WorkerThread* m_pThreadWorker;
	bool m_bThreadFinished;
	ActionList m_listActionDone;
	wxMutex m_mutex;	// protects m_strCurrentAction from multiple threads
	wxString m_strCurrentAction;	
	int m_nCurrentRow;
};

class WorkerThread : public wxThread
{
public:
	WorkerThread(TransferDlg* pParent, ActionList &listAction, Nomad* pNomad);
	virtual ExitCode Entry();
	virtual void OnExit();
private:
	ActionList &m_listAction;
	Nomad* m_pNomad;
	TransferDlg* m_pParent;
};



#endif
