#ifndef _REPAIRMP3TAGSDLG_H_INCLUDED_
#define _REPAIRMP3TAGSDLG_H_INCLUDED_

#include "Config.h"
#include "ActionTable.h"

class EzGrid;
class wxGridEvent;
class Nomad;
class TransferDlg;
class TrackMatcher;
class PlaylistMatcher;
class Matcher;
class TrackCache;


//	NomadSyncDlg is the main dialog class
class NomadSyncDlg : public wxDialog
{
public:
	NomadSyncDlg(const wxString& title);
	~NomadSyncDlg();
private:
	void OnQuit(wxCommandEvent& event);
	void Init();
	void OnUpdate(wxCommandEvent& event);
	void OnSearch(wxCommandEvent& event);
	void OnPlaylists(wxCommandEvent& event);
	void OnConfig(wxCommandEvent& event);
	void OnHTMLHelp(wxCommandEvent& WXUNUSED(event));
	void OnAbout(wxCommandEvent& WXUNUSED(event));
	void OnCellValueChanged(wxGridEvent& ev);
	void CheckActionsToDo();
	ActionList::iterator FindAction(int nRow);
	void OnContextMenu(wxCommandEvent& event);
	void OnRightClick(wxGridEvent& event); 
	void OnLabelLeftClick(wxGridEvent& event); 
	bool GetMp3OpenCommand();
	void Search(Matcher* pMatcher, const char* szMessage);
	DECLARE_EVENT_TABLE()
	EzGrid* m_pGrid;
	ActionTable m_tableAction;		// stores the data of the grid
	TransferDlg* m_pDlgTransfer;
	TrackMatcher* m_pTrackMatcher;
	PlaylistMatcher* m_pPlaylistMatcher;
	TrackCache* m_pTrackCache;
	Config m_config;					// stores user configuration settings
	wxButton* m_pBtnUpdate; 
	wxBitmapButton* m_pBtnSearch;
	wxBitmapButton* m_pBtnPlaylists;
	wxStaticText* m_pLblStatus;	// gives user feedback for different stages in search 
	Nomad* m_pNomad;
	FILE* m_pLogFile;
	wxArrayString m_listMp3Verbs;		// mp3 commands read from registry
	wxArrayString m_listMp3Commands;
	int m_nRightClickRow;		// remembers row number where you right clicked				
};

#endif // _REPAIRMP3TAGSDLG_H_INCLUDED_
