#ifndef _PLAYLIST_H_INCLUDED_
#define _PLAYLIST_H_INCLUDED_

using namespace std;
class Track;
typedef vector<Track*> TrackList;
typedef map<wxString, Track*> TrackMap; 

const int c_nPCTracksMissing = 1;
const int c_nNomadTracksMissing = 2;


class Playlist
{
public:
	Playlist() : m_nItemID(0), m_nErrorMask(0) {}
	~Playlist() {}
	Playlist(const Playlist& rhs);
	bool HasSameTracks(const Playlist* pPlayList) const;
	const wxString& GetName() const
	{
		return m_strName;
	}
	void SetName(const wxString& strName)
	{
		m_strName = strName;
	}
	const wxString& GetFileSpec() const
	{
		return m_strFileSpec;
	}
	void SetFileSpec(const wxString& strFileSpec)
	{
		m_strFileSpec = strFileSpec;
	}
	unsigned int GetItemID() const
	{
		return m_nItemID;
	}
	void SetItemID(unsigned int nItemID)
	{
		m_nItemID = nItemID;
	}
	void Add(Track* pTrack);
	void AddNoDups(Track* pTrack);
	TrackList& GetNomadListTrack() 
	{
		if (IsNomad())	return m_listTrack;
		return m_listTransTrack;
	}
	bool ParseFile(const TrackMap& mapPC);
	bool WriteM3uFile(const wxString& strDir);
	void TransformTracks(const TrackMap& mapPC);
	bool IsNomad() const
	{
		return m_strFileSpec.IsEmpty();
	}
	wxString GetValue(int nCol) const;
	bool ColIsLessThan(int nCol, const Playlist* pPlaylist) const;
	bool CanTransfer() const
	{
		return m_listTransTrack.size() > 0;
	}
private:
	wxString m_strName;
	wxString m_strFileSpec;
	unsigned int m_nItemID;		
	TrackList m_listTrack;
	TrackList m_listTransTrack;
	int m_nErrorMask;
};





#endif // _PLAYLIST_H_INCLUDED_
