#ifndef _PLAYLISTACTION_H_INCLUDED_
#define _PLAYLISTACTION_H_INCLUDED_

#include "Action.h"

class Playlist;

// class that handles actions performed on tracks
class PlaylistAction : public Action
{
public:
	PlaylistAction(const Config& config);
	virtual ~PlaylistAction();
	virtual bool SetAction(ActionEnum action);
	virtual bool DoAction(BaseNomad* pNomad);
	virtual bool DoPostAction(unsigned int) 
	{ 
		m_bExecuting = false;
		return true;
	}
	virtual int GetTimeNeeded() const;
	virtual wxString GenErrorMsg() const;
	virtual wxString GetDisplayStr() const;
	virtual wxString GetValue(int nCol, int nTrackIX) const;
	virtual wxGridCellAttr* GetAttr(int nCol, int nTrackIX, 
		CellAttrCache& attrCache) const;
	virtual void SetDefault(); 
	virtual bool ColIsLessThan(int nCol, const Action* pAction) const;
	int GetTypeOrder() const;	
	virtual bool IsPaired() const;
	virtual Action* CheckSplit() { return NULL;}
	virtual bool MergeActions(Action* pNextAction)
	{ return false; }
	virtual void SetDependAction(Action* pDependAction)
	{
		m_pDependAction = (PlaylistAction*)pDependAction;
	}
	virtual Action* GetDependAction() const
	{
		return m_pDependAction;
	}
	virtual bool IsLabelAction() const { return false; }
	Playlist* GetPlaylist() const
	{
		return m_pPlaylist;
	}
	void SetPlaylist(Playlist* pPlaylist)
	{
		m_pPlaylist = pPlaylist;
	}
private:
	Playlist* m_pPlaylist;
	PlaylistAction* m_pDependAction;
};






#endif // _PLAYLISTACTION_H_INCLUDED_
