#ifndef _PLAYLISTMATCHER_H_INCLUDED_
#define _PLAYLISTMATCHER_H_INCLUDED_


#include "TrackMatcher.h"
class Playlist;

typedef vector<Playlist*> PlaylistList;
typedef map<wxString, Playlist*> PlaylistMap;

class PlaylistPair
{
public:
	PlaylistPair(Playlist* pPC, Playlist* pNomad) : m_pPC(pPC),
		m_pNomad(pNomad) {}
	Playlist* m_pPC;
	Playlist* m_pNomad;
};



class PlaylistMatcher : public Matcher
{
public:
	PlaylistMatcher(TrackCache* pTrackCache, const Config& config) : 
		Matcher(pTrackCache, config)
	{
	}
	virtual ~PlaylistMatcher();
	virtual void RemoveAll();
	virtual void Run(Nomad* pNomad);
	virtual wxDirTraverseResult OnFile(const wxString& strFilename);
	virtual void CreateActions(ActionTable& table) const;
private:
	void OnPlayListFile(const wxString& strFileSpec);
	virtual void Match();
	void CreateNomadPlaylists(const Nomad* pNomad);
	PlaylistMap m_mapPCPlaylist;
	PlaylistMap m_mapNomadPlaylist;
	vector<Playlist*> m_listPCExtraPlaylist;
	// m_listDiffPlaylist stores playlists with same name but different tracks
	vector<PlaylistPair> m_listDiffPlaylist;
};


#endif // _PLAYLISTMATCHER_H_INCLUDED_
