#ifndef _TRACKACTION_H_INCLUDED_
#define _TRACKACTION_H_INCLUDED_


#include "Action.h"

class Track;

// class that handles actions performed on tracks
class TrackAction : public Action
{
public:
	TrackAction(const Config& config);
	virtual ~TrackAction();
	virtual bool SetAction(ActionEnum action);
	void SetTrack(int nIndex, Track* pTrack)
	{
		m_pTrack[nIndex] = pTrack;
	}
	Track* GetTrack(int nIndex) const
	{
		return m_pTrack[nIndex];
	}
	virtual bool DoAction(BaseNomad* pNomad);
	virtual bool DoPostAction(unsigned int nItemID);
	virtual int GetTimeNeeded() const;
	virtual wxString GenErrorMsg() const;
	virtual wxString GetDisplayStr() const;
	virtual wxString GetValue(int nCol, int nTrackIX) const;
	virtual wxGridCellAttr* GetAttr(int nCol, int nTrackIX, 
		CellAttrCache& attrCache) const;
	virtual void SetDefault(); 
	virtual bool ColIsLessThan(int nCol, const Action* pAction) const;
	int GetTypeOrder() const;	
	virtual bool IsPaired() const;
	virtual bool IsLabelAction() const
	{
		return m_pTrack[1] != NULL;
	}
	virtual Action* CheckSplit();
	virtual bool MergeActions(Action* pNextAction);
	virtual void SetDependAction(Action* pDependAction)
	{
		m_pDependAction = (TrackAction*)pDependAction;
	}
	virtual Action* GetDependAction() const
	{
		return m_pDependAction;
	}
private:
	Track* m_pTrack[2];
	TrackAction* m_pDependAction;
};







#endif // _TRACKACTION_H_INCLUDED_
