#ifndef _TRACKCACHE_H_INCLUDED_
#define _TRACKCACHE_H_INCLUDED_

using namespace std;

class Track;

typedef vector<Track*> TrackList;
typedef map<wxString, Track*> TrackMap; 

// TrackCache reads and writes all track data to a cache file
// for speedy mp3 searches
class TrackCache
{
public:
	TrackCache() {}
	~TrackCache();
	void RemoveHits()
	{
		m_listPCAll.clear();
	}
	void WriteCacheFile(const wxString& strFileSpec);
	void ReadCacheFile(const wxString& strFileSpec);
	Track* GetFile(const wxString& strFileSpec);
	int GetNumTracks() const
	{
		return m_listPCAll.size();
	}
	const TrackMap& GetMapPCCache() const
	{
		return m_mapPCCache;
	}
private:
	// m_listPCAll only contains hits from the last search
	// used to elimenate dead cache entries
	TrackList m_listPCAll;
	//	m_mapPCCache indexed by filespec
	TrackMap m_mapPCCache;
};





#endif // _TRACKCACHE_H_INCLUDED_
